using Microsoft.EntityFrameworkCore;
using System.ComponentModel.DataAnnotations.Schema;

namespace Elwig.Models {
    [Table("payment_delivery_part"), PrimaryKey("Year", "DId", "DPNr", "AvNr")]
    public class PaymentDeliveryPart {
        [Column("year")]
        public int Year { get; set; }

        [Column("did")]
        public int DId { get; set; }

        [Column("dpnr")]
        public int DPNr { get; set; }

        [Column("avnr")]
        public int AvNr { get; set; }

        [Column("mod_abs")]
        public long ModAbsValue { get; set; }
        [NotMapped]
        public decimal ModAbs {
            get => Variant.Season.DecFromDb(ModAbsValue);
            set => ModAbsValue = Variant.Season.DecToDb(value);
        }

        [Column("mod_rel")]
        public double ModRelValue { get; set; }
        [NotMapped]
        public decimal ModRel {
            get => (decimal)ModRelValue;
            set => ModRelValue = (double)value;
        }

        [Column("amount")]
        public long? AmountValue { get; set; }
        [NotMapped]
        public decimal? Amount {
            get => AmountValue != null ? Variant.Season.DecFromDb(AmountValue.Value) : null;
            set => AmountValue = value != null ? Variant.Season.DecToDb(value.Value) : null;
        }

        [ForeignKey("Year, AvNr")]
        public virtual PaymentVar Variant { get; private set; }

        [ForeignKey("Year, DId, DPNr")]
        public virtual DeliveryPart DeliveryPart { get; private set; }
    }
}
