using System.Reflection;
using System.Windows;

namespace Elwig.Windows {
    public partial class MainWindow : Window {

        public MainWindow() {
            InitializeComponent();
            var v = Assembly.GetExecutingAssembly().GetName().Version;
            VersionField.Text = "Version: " + (v == null ? "?" : $"{v.Major}.{v.Minor}.{v.Build}");
            if (!App.Config.Debug) {
                TestWindowButton.Visibility = Visibility.Hidden;
                //QueryWindowButton.Visibility = Visibility.Hidden;
            }
        }

        private void Window_Loaded(object sender, RoutedEventArgs evt) { }

        private void MemberAdminButton_Click(object sender, RoutedEventArgs evt) {
            var w = new MemberAdminWindow();
            w.Show();
        }

        private void MemberListButton_Click(object sender, RoutedEventArgs evt) {
            var w = new MemberListWindow();
            w.Show();
        }

        private void ReceiptButton_Click(object sender, RoutedEventArgs evt) {
            var w = new DeliveryAdminWindow(true);
            w.Show();
        }

        private void DeliveryAdminButton_Click(object sender, RoutedEventArgs evt) {
            var w = new DeliveryAdminWindow();
            w.Show();
        }

        private void DeliveryListButton_Click(object sender, RoutedEventArgs evt) {
            // TODO
        }

        private void TestWindowButton_Click(object sender, RoutedEventArgs evt) {
            var w = new TestWindow();
            w.Show();
        }

        private void QueryWindowButton_Click(object sender, RoutedEventArgs evt) {
            var w = new QueryWindow();
            w.Show();
        }

        private void BaseDataButton_Click(object sender, RoutedEventArgs evt) {
            var w = new BaseDataWindow();
            w.Show();
        }

        private void SeasonFinishButton_Click(object sender, RoutedEventArgs e) {
            var w = new SeasonFinishWindow();
            w.Show();
        }
    }
}
